// =======================================================================
//
// MAS22_Meshing.h
// CBBP 24-07-22
// Playground to explore procedural meshes
//
// =======================================================================
#pragma once

#include "CoreMinimal.h"
#include "MAS22_Actor.h"
#include "ProceduralMeshComponent.h"

#include "MAS22_Meshing.generated.h"


UCLASS()
class MAS22_SCIENCEPARK_API AMAS22_Meshing : public AMAS22_Actor
{
	GENERATED_BODY()
	
	UPROPERTY(VisibleDefaultsOnly)
		class UProceduralMeshComponent* pMesh;

	UPROPERTY(VisibleDefaultsOnly)
		class UStaticMeshComponent* Ball;

	UPROPERTY(EditAnywhere)
		FVector2D Size = FVector2D(1000.0f, 100.0f);

	// width and height should be the same ------ ??

	UPROPERTY(EditAnywhere)
		int width = 7;

	UPROPERTY(EditAnywhere)
		int length = 511;

	TArray<float> heightArray;

	TArray<FVector> vertexArray;
	TArray<int32> triangleArray;
	TArray<FVector> normalsArray;
	TArray<FVector2D> texCoords;

public:
	AMAS22_Meshing();

protected:

	virtual void ActorInitialize() override;
	virtual void ComputeDT() override;

	void generateHeights();
	void generateHeightsOnePulse();
	void generateGrid(TArray<FVector>& InVertices, TArray<int32>& InTriangles, TArray<FVector>& InNormals, TArray<FVector2D>& InTexCoords, const FVector2D InSize, const int32 InLengthSections, const int32 InWidthSections, const TArray<float>& InHeightValues);
	void generateMesh();

};
