// ============================================================================
// CBP + FBO = MAS22 Simulation Framework
// 20-12-21
// MAS22_Pawn.cpp
// ============================================================================


#include "MAS22_Pawn.h"
#include "Components/SphereComponent.h"
#include "Camera/CameraComponent.h"
#include "GameFramework/PlayerInput.h"

FName AMAS22_Pawn::CollCompName(TEXT("CollisionComponent0"));
// Sets default values
AMAS22_Pawn::AMAS22_Pawn()
{
 	// Set this pawn to call Tick() every frame.  You can turn this off to improve performance if you don't need it.
	PrimaryActorTick.bCanEverTick = true;

	speed = 500.0f;
	direction = FVector2D(0.0f, 0.0f);

	FirstPersonCameraComponent =
		CreateDefaultSubobject<UCameraComponent>(TEXT("FirstPersonCamera"));
	FirstPersonCameraComponent->SetupAttachment(RootComponent);
	FirstPersonCameraComponent->SetRelativeLocation(FVector(0.0f, 0.0f, 1.0f));
	FirstPersonCameraComponent->bUsePawnControlRotation = true;
}

// Called when the game starts or when spawned
void AMAS22_Pawn::BeginPlay()
{
	Super::BeginPlay();

	//GEngine->AddOnScreenDebugMessage(-1, 5.0f, FColor::Yellow,
	//	FString::Printf(TEXT("AMAS22_Pawn::BeginPlay()")));
	
}

// Called every frame
void AMAS22_Pawn::Tick(float DeltaTime)
{
	Super::Tick(DeltaTime);

	if (!direction.IsZero()) {
		FVector Location = GetActorLocation();
		FVector deltaLocation = FVector(direction.X, direction.Y, 0.0f);
		deltaLocation.Normalize();
		deltaLocation *= speed * DeltaTime;
		Location += deltaLocation;
		SetActorLocation(Location);
		//GEngine->AddOnScreenDebugMessage(-1, 5.0f, FColor::Yellow,
		//	FString::Printf(TEXT("xcpt %e, ycpt %e, zcpt %e"), Location.X, Location.Y, Location.Z));
	}

}


// Called to bind functionality to input
void AMAS22_Pawn::SetupPlayerInputComponent(UInputComponent* PlayerInputComponent)
{
	Super::SetupPlayerInputComponent(PlayerInputComponent);

}


