// =======================================================================
// SParamLineWidget.cpp
// CBP 16-05-22
// class for SparamMenuWidget parameter line
// Rev 19-05-22
// =======================================================================

#include "SParamLineWidget.h"
#include "Widgets/SWeakWidget.h"
#include "MAS22_Structs.h"
#include "MAS22_PlayerController.h"
#include "SParamMenuWidget.h"

	void SParamLineWidget::Construct(const FArguments& InArgs) {
		//printf("Making SParamLineWidget");
		ChildSlot
			[
				SNew(SHorizontalBox)
				+ SHorizontalBox::Slot()
				.Padding(0.0f, 0.0f, 0.0f, 0.0f)
				.AutoWidth()
				//.WidthOVerride(200.0f)
			[
				SNew(STextBlock)
			]
			
		+ SHorizontalBox::Slot()
			.FillWidth(1.f)
			[
				SNew(SButton)
				[
					SNew(SSpinBox<float>)
					.MinValue(0.0f)
					.MaxValue(100.0f)
					.OnValueChanged(this, &SParamLineWidget::SpinBoxChanged)
					.Value(this, &SParamLineWidget::GetUpdatedValue)
			]

			]

			];


	}
	float SParamLineWidget::GetUpdatedValue() const {
		return val;
	}

	void SParamLineWidget::SetID(int id) {
		ID = id;
		//printf("SParamLineWidget::SetID() ID set to %d", ID);
	}

	// Called when value is changed
	void SParamLineWidget::SpinBoxChanged(float newVal) {
		// Write new value into the spin box
		SetVal(newVal);
		//printf("SParamLineWidget::SpinBoxChanged() ID = %d Changed to %f", ID, newVal);
		menuWidget->UpdateLine(ID, val);
	}

	// called from SParamMenuWidget and also this
	void SParamLineWidget::SetVal(double _val) {
		val = _val;
	}

	void SParamLineWidget::SetMenuWidget(SParamMenuWidget* _menuWidget) {
		menuWidget = _menuWidget;
	}

